<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.9.1"/>
<title>Flair: flair::core::Vector3D&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="logo_hds.png"/></td>
  <td style="padding-left: 0.5em;">
   <div id="projectname">Flair
   </div>
   <div id="projectbrief">Framework Libre Air</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.9.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classflair_1_1core_1_1_vector3_d.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classflair_1_1core_1_1_vector3_d-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">flair::core::Vector3D&lt; T &gt; Class Template Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Class defining a 3D vector.  
 <a href="classflair_1_1core_1_1_vector3_d.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_vector3_d_8h_source.html">Vector3D.h</a>&gt;</code></p>
<div id="dynsection-0" onclick="return toggleVisibility(this)" class="dynheader closed" style="cursor:pointer;">
  <img id="dynsection-0-trigger" src="closed.png" alt="+"/> Inheritance diagram for flair::core::Vector3D&lt; T &gt;:</div>
<div id="dynsection-0-summary" class="dynsummary" style="display:block;">
</div>
<div id="dynsection-0-content" class="dyncontent" style="display:none;">
 <div class="center">
  <img src="classflair_1_1core_1_1_vector3_d.png" usemap="#flair::core::Vector3D&lt; T &gt;_map" alt=""/>
  <map id="flair::core::Vector3D&lt; T &gt;_map" name="flair::core::Vector3D&lt; T &gt;_map">
<area href="classflair_1_1core_1_1_vector3_ddata.html" title="Class defining a 3D vector and a io_data User must manually use the io_data&#39;s Mutex to access to Vect..." alt="flair::core::Vector3Ddata" shape="rect" coords="0,56,157,80"/>
</map>
 </div></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a4434fbd95b0f760a7f374d8068238c87"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a4434fbd95b0f760a7f374d8068238c87">Vector3D</a> (T <a class="el" href="classflair_1_1core_1_1_vector3_d.html#abb356ca2add4d7cd62c3e1772ce84a4f">x</a>=0, T <a class="el" href="classflair_1_1core_1_1_vector3_d.html#a62a7b867d542c4aee7634f8a58b25256">y</a>=0, T <a class="el" href="classflair_1_1core_1_1_vector3_d.html#ab0c47253b9de56abf0fbe9661f9e1812">z</a>=0)</td></tr>
<tr class="memdesc:a4434fbd95b0f760a7f374d8068238c87"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a4434fbd95b0f760a7f374d8068238c87">More...</a><br /></td></tr>
<tr class="separator:a4434fbd95b0f760a7f374d8068238c87"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae09b7edbe9f6be35b9f171eefd401b99"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#ae09b7edbe9f6be35b9f171eefd401b99">~Vector3D</a> ()</td></tr>
<tr class="memdesc:ae09b7edbe9f6be35b9f171eefd401b99"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#ae09b7edbe9f6be35b9f171eefd401b99">More...</a><br /></td></tr>
<tr class="separator:ae09b7edbe9f6be35b9f171eefd401b99"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a195e8601b80e5e85a4d361c5a9b746a0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a195e8601b80e5e85a4d361c5a9b746a0">RotateX</a> (float value)</td></tr>
<tr class="memdesc:a195e8601b80e5e85a4d361c5a9b746a0"><td class="mdescLeft">&#160;</td><td class="mdescRight">x axis rotation  <a href="#a195e8601b80e5e85a4d361c5a9b746a0">More...</a><br /></td></tr>
<tr class="separator:a195e8601b80e5e85a4d361c5a9b746a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a70eb14b1c286020f1e5a092a6188b361"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a70eb14b1c286020f1e5a092a6188b361">RotateXDeg</a> (float value)</td></tr>
<tr class="memdesc:a70eb14b1c286020f1e5a092a6188b361"><td class="mdescLeft">&#160;</td><td class="mdescRight">x axis rotation  <a href="#a70eb14b1c286020f1e5a092a6188b361">More...</a><br /></td></tr>
<tr class="separator:a70eb14b1c286020f1e5a092a6188b361"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a47b3902a89379a918cd9f5441aa7c748"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a47b3902a89379a918cd9f5441aa7c748">RotateY</a> (float value)</td></tr>
<tr class="memdesc:a47b3902a89379a918cd9f5441aa7c748"><td class="mdescLeft">&#160;</td><td class="mdescRight">y axis rotation  <a href="#a47b3902a89379a918cd9f5441aa7c748">More...</a><br /></td></tr>
<tr class="separator:a47b3902a89379a918cd9f5441aa7c748"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57a22e954ffffa6f9c8d828788ac1eac"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a57a22e954ffffa6f9c8d828788ac1eac">RotateYDeg</a> (float value)</td></tr>
<tr class="memdesc:a57a22e954ffffa6f9c8d828788ac1eac"><td class="mdescLeft">&#160;</td><td class="mdescRight">y axis rotation  <a href="#a57a22e954ffffa6f9c8d828788ac1eac">More...</a><br /></td></tr>
<tr class="separator:a57a22e954ffffa6f9c8d828788ac1eac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaa82d7a6693e70ff7b242aceb977e9c0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#aaa82d7a6693e70ff7b242aceb977e9c0">RotateZ</a> (float value)</td></tr>
<tr class="memdesc:aaa82d7a6693e70ff7b242aceb977e9c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">z axis rotation  <a href="#aaa82d7a6693e70ff7b242aceb977e9c0">More...</a><br /></td></tr>
<tr class="separator:aaa82d7a6693e70ff7b242aceb977e9c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3cd28096c5b268d44fae64ff3de97c60"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a3cd28096c5b268d44fae64ff3de97c60">RotateZDeg</a> (float value)</td></tr>
<tr class="memdesc:a3cd28096c5b268d44fae64ff3de97c60"><td class="mdescLeft">&#160;</td><td class="mdescRight">z axis rotation  <a href="#a3cd28096c5b268d44fae64ff3de97c60">More...</a><br /></td></tr>
<tr class="separator:a3cd28096c5b268d44fae64ff3de97c60"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b55225f9547b97a21758c1e2b65dea3"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a5b55225f9547b97a21758c1e2b65dea3">Rotate</a> (const <a class="el" href="classflair_1_1core_1_1_rotation_matrix.html">RotationMatrix</a> &amp;matrix)</td></tr>
<tr class="memdesc:a5b55225f9547b97a21758c1e2b65dea3"><td class="mdescLeft">&#160;</td><td class="mdescRight">rotation  <a href="#a5b55225f9547b97a21758c1e2b65dea3">More...</a><br /></td></tr>
<tr class="separator:a5b55225f9547b97a21758c1e2b65dea3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1c4c2cbb39ec5583856b3114924d6f86"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a1c4c2cbb39ec5583856b3114924d6f86">Rotate</a> (const <a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;quaternion)</td></tr>
<tr class="memdesc:a1c4c2cbb39ec5583856b3114924d6f86"><td class="mdescLeft">&#160;</td><td class="mdescRight">rotation  <a href="#a1c4c2cbb39ec5583856b3114924d6f86">More...</a><br /></td></tr>
<tr class="separator:a1c4c2cbb39ec5583856b3114924d6f86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2ca154983653645e266a1c2331222a79"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a2ca154983653645e266a1c2331222a79">To2Dxy</a> (<a class="el" href="classflair_1_1core_1_1_vector2_d.html">Vector2D</a>&lt; T &gt; &amp;vector) const </td></tr>
<tr class="memdesc:a2ca154983653645e266a1c2331222a79"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert to a <a class="el" href="classflair_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>.  <a href="#a2ca154983653645e266a1c2331222a79">More...</a><br /></td></tr>
<tr class="separator:a2ca154983653645e266a1c2331222a79"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af7bca23dab226f26818cddcac3771b0e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classflair_1_1core_1_1_vector2_d.html">Vector2D</a>&lt; T &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#af7bca23dab226f26818cddcac3771b0e">To2Dxy</a> (void) const </td></tr>
<tr class="memdesc:af7bca23dab226f26818cddcac3771b0e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Convert to a <a class="el" href="classflair_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>.  <a href="#af7bca23dab226f26818cddcac3771b0e">More...</a><br /></td></tr>
<tr class="separator:af7bca23dab226f26818cddcac3771b0e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4249aef85a1848a2952dfafbe6caad12"><td class="memItemLeft" align="right" valign="top">float&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a4249aef85a1848a2952dfafbe6caad12">GetNorm</a> (void) const </td></tr>
<tr class="memdesc:a4249aef85a1848a2952dfafbe6caad12"><td class="mdescLeft">&#160;</td><td class="mdescRight">Norm.  <a href="#a4249aef85a1848a2952dfafbe6caad12">More...</a><br /></td></tr>
<tr class="separator:a4249aef85a1848a2952dfafbe6caad12"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8230b1bbc50b49afac2758e44bcbb02c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a8230b1bbc50b49afac2758e44bcbb02c">Normalize</a> (void)</td></tr>
<tr class="memdesc:a8230b1bbc50b49afac2758e44bcbb02c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Normalize.  <a href="#a8230b1bbc50b49afac2758e44bcbb02c">More...</a><br /></td></tr>
<tr class="separator:a8230b1bbc50b49afac2758e44bcbb02c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a82a85beea28856be5b64f1d773ecebec"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a82a85beea28856be5b64f1d773ecebec">Saturate</a> (const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;min, const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;max)</td></tr>
<tr class="memdesc:a82a85beea28856be5b64f1d773ecebec"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#a82a85beea28856be5b64f1d773ecebec">More...</a><br /></td></tr>
<tr class="separator:a82a85beea28856be5b64f1d773ecebec"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a99cd39aa3d52bea0d6f6227f950b3775"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a99cd39aa3d52bea0d6f6227f950b3775">Saturate</a> (float min, float max)</td></tr>
<tr class="memdesc:a99cd39aa3d52bea0d6f6227f950b3775"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#a99cd39aa3d52bea0d6f6227f950b3775">More...</a><br /></td></tr>
<tr class="separator:a99cd39aa3d52bea0d6f6227f950b3775"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0ce7a8a1fd1a493fa23963d80189b500"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a0ce7a8a1fd1a493fa23963d80189b500">Saturate</a> (const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;value)</td></tr>
<tr class="memdesc:a0ce7a8a1fd1a493fa23963d80189b500"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#a0ce7a8a1fd1a493fa23963d80189b500">More...</a><br /></td></tr>
<tr class="separator:a0ce7a8a1fd1a493fa23963d80189b500"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a057004d70fec9ca92fc47b8f02eb44ed"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a057004d70fec9ca92fc47b8f02eb44ed">Saturate</a> (float value)</td></tr>
<tr class="memdesc:a057004d70fec9ca92fc47b8f02eb44ed"><td class="mdescLeft">&#160;</td><td class="mdescRight">Saturate.  <a href="#a057004d70fec9ca92fc47b8f02eb44ed">More...</a><br /></td></tr>
<tr class="separator:a057004d70fec9ca92fc47b8f02eb44ed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2e8eff1377049ede3441a8d249f2bbaf"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a2e8eff1377049ede3441a8d249f2bbaf"></a>
T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (size_t idx)</td></tr>
<tr class="separator:a2e8eff1377049ede3441a8d249f2bbaf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a22ec1b9cd25423fb0aed4f1254825013"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a22ec1b9cd25423fb0aed4f1254825013"></a>
const T &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator[]</b> (size_t idx) const </td></tr>
<tr class="separator:a22ec1b9cd25423fb0aed4f1254825013"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abc4d4c8113a4138f510cdd21e38dbe96"><td class="memTemplParams" colspan="2"><a class="anchor" id="abc4d4c8113a4138f510cdd21e38dbe96"></a>
template&lt;typename S &gt; </td></tr>
<tr class="memitem:abc4d4c8113a4138f510cdd21e38dbe96"><td class="memTemplItemLeft" align="right" valign="top"><a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;&#160;</td><td class="memTemplItemRight" valign="bottom"><b>operator=</b> (const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; S &gt; &amp;vector)</td></tr>
<tr class="separator:abc4d4c8113a4138f510cdd21e38dbe96"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afb9650fac2fe8aaef7ee32cd45330b02"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="afb9650fac2fe8aaef7ee32cd45330b02"></a>
<a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator+=</b> (const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;vector)</td></tr>
<tr class="separator:afb9650fac2fe8aaef7ee32cd45330b02"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a243c5bd66cb20687d6db891517a696f9"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a243c5bd66cb20687d6db891517a696f9"></a>
<a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>operator-=</b> (const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;vector)</td></tr>
<tr class="separator:a243c5bd66cb20687d6db891517a696f9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:abb356ca2add4d7cd62c3e1772ce84a4f"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#abb356ca2add4d7cd62c3e1772ce84a4f">x</a></td></tr>
<tr class="memdesc:abb356ca2add4d7cd62c3e1772ce84a4f"><td class="mdescLeft">&#160;</td><td class="mdescRight">x  <a href="#abb356ca2add4d7cd62c3e1772ce84a4f">More...</a><br /></td></tr>
<tr class="separator:abb356ca2add4d7cd62c3e1772ce84a4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62a7b867d542c4aee7634f8a58b25256"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#a62a7b867d542c4aee7634f8a58b25256">y</a></td></tr>
<tr class="memdesc:a62a7b867d542c4aee7634f8a58b25256"><td class="mdescLeft">&#160;</td><td class="mdescRight">y  <a href="#a62a7b867d542c4aee7634f8a58b25256">More...</a><br /></td></tr>
<tr class="separator:a62a7b867d542c4aee7634f8a58b25256"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab0c47253b9de56abf0fbe9661f9e1812"><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classflair_1_1core_1_1_vector3_d.html#ab0c47253b9de56abf0fbe9661f9e1812">z</a></td></tr>
<tr class="memdesc:ab0c47253b9de56abf0fbe9661f9e1812"><td class="mdescLeft">&#160;</td><td class="mdescRight">z  <a href="#ab0c47253b9de56abf0fbe9661f9e1812">More...</a><br /></td></tr>
<tr class="separator:ab0c47253b9de56abf0fbe9661f9e1812"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename T&gt;<br />
class flair::core::Vector3D&lt; T &gt;</h3>

<p>Class defining a 3D vector. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a4434fbd95b0f760a7f374d8068238c87"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::<a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a> </td>
          <td>(</td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>x</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>y</em> = <code>0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T&#160;</td>
          <td class="paramname"><em>z</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>Construct a <a class="el" href="classflair_1_1core_1_1_vector3_d.html" title="Class defining a 3D vector. ">Vector3D</a> using specified values.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">x</td><td></td></tr>
    <tr><td class="paramname">y</td><td></td></tr>
    <tr><td class="paramname">z</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ae09b7edbe9f6be35b9f171eefd401b99"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::~<a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a195e8601b80e5e85a4d361c5a9b746a0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::RotateX </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>x axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in radians </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a70eb14b1c286020f1e5a092a6188b361"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::RotateXDeg </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>x axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in degrees </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a47b3902a89379a918cd9f5441aa7c748"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::RotateY </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>y axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in radians </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a57a22e954ffffa6f9c8d828788ac1eac"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::RotateYDeg </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>y axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in degrees </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aaa82d7a6693e70ff7b242aceb977e9c0"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::RotateZ </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>z axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in radians </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a3cd28096c5b268d44fae64ff3de97c60"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::RotateZDeg </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>z axis rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>rotation value in degrees </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a5b55225f9547b97a21758c1e2b65dea3"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::Rotate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_rotation_matrix.html">RotationMatrix</a> &amp;&#160;</td>
          <td class="paramname"><em>matrix</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>rotation </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">matrix</td><td>rotation matrix </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1c4c2cbb39ec5583856b3114924d6f86"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::Rotate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_quaternion.html">Quaternion</a> &amp;&#160;</td>
          <td class="paramname"><em>quaternion</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>rotation </p>
<p>Compute a rotation from a quaternion. This method uses a rotation matrix internaly.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">quaternion</td><td>quaternion </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a2ca154983653645e266a1c2331222a79"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::To2Dxy </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classflair_1_1core_1_1_vector2_d.html">Vector2D</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>vector</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert to a <a class="el" href="classflair_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>. </p>
<p>Uses x and y coordinates.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">vector</td><td>destination </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="af7bca23dab226f26818cddcac3771b0e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classflair_1_1core_1_1_vector2_d.html">Vector2D</a>&lt;T&gt; <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::To2Dxy </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Convert to a <a class="el" href="classflair_1_1core_1_1_vector2_d.html" title="Class defining a 2D vector. ">Vector2D</a>. </p>
<p>Uses x and y coordinates.</p>
<dl class="section return"><dt>Returns</dt><dd>destination </dd></dl>

</div>
</div>
<a class="anchor" id="a4249aef85a1848a2952dfafbe6caad12"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">float <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::GetNorm </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Norm. </p>
<dl class="section return"><dt>Returns</dt><dd>value </dd></dl>

</div>
</div>
<a class="anchor" id="a8230b1bbc50b49afac2758e44bcbb02c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::Normalize </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Normalize. </p>

</div>
</div>
<a class="anchor" id="a82a85beea28856be5b64f1d773ecebec"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::Saturate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between min and max</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">min</td><td>minimum value </td></tr>
    <tr><td class="paramname">max</td><td>maximum value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a99cd39aa3d52bea0d6f6227f950b3775"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::Saturate </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>min</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>max</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between min and max</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">min</td><td>minimum Vector3D(min,min,min) value </td></tr>
    <tr><td class="paramname">max</td><td>maximum Vector3D(max,max,max) value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0ce7a8a1fd1a493fa23963d80189b500"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::Saturate </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between -abs(value) and abs(value)</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>saturation <a class="el" href="classflair_1_1core_1_1_vector3_d.html" title="Class defining a 3D vector. ">Vector3D</a> value </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a057004d70fec9ca92fc47b8f02eb44ed"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::Saturate </td>
          <td>(</td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Saturate. </p>
<p>Saturate between -abs(Vector3D(value,value,value)) and abs(Vector3D(value,value,value))</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>saturation Vector3D(value,value,value) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="abb356ca2add4d7cd62c3e1772ce84a4f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::x</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>x </p>

</div>
</div>
<a class="anchor" id="a62a7b867d542c4aee7634f8a58b25256"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::y</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>y </p>

</div>
</div>
<a class="anchor" id="ab0c47253b9de56abf0fbe9661f9e1812"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classflair_1_1core_1_1_vector3_d.html">flair::core::Vector3D</a>&lt; T &gt;::z</td>
        </tr>
      </table>
</div><div class="memdoc">

<p>z </p>

</div>
</div>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespaceflair.html">flair</a></li><li class="navelem"><a class="el" href="namespaceflair_1_1core.html">core</a></li><li class="navelem"><a class="el" href="classflair_1_1core_1_1_vector3_d.html">Vector3D</a></li>
    <li class="footer">Generated on Thu Jan 31 2019 12:34:23 for Flair by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.9.1 </li>
  </ul>
</div>
</body>
</html>
